
--- 
stages:
  - build
  - get_kube_config
  - helm-environments-diff
  - helm-environments-apply
  - restore_db
  - deploy_application

variables:
  DOCKER_REGISTRY_NAME: atalabirchuk
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: "tcp://docker:2375"
  REPLICAS_MASTER: "2"
  REPLICAS_DEVEL: "1"

.docker_dind:
  image: 
    name: docker:18.09.7
    entrypoint: [""]
  services:
    - docker:18.09.7-dind

.helmfile:
  image:
    name: quay.io/roboll/helmfile:helm3-v0.104.0
    entrypoint: [""]
  before_script:
    - mkdir -p ~/.kube
    - echo $KUBE_CONFIG | base64 -d > ~/.kube/config

.google-kubectl:
  image: 
    name: atalabirchuk/google:0.0.1
    entrypoint: [""]
  before_script:
    - mkdir -p ~/.kube
    - echo $KUBE_CONFIG | base64 -d > ~/.kube/config  

build_image_dev:
  stage: build
  extends: .docker_dind
  script:
    - echo $DOCKER_REGISTRY_PASS | docker login -u $DOCKER_REGISTRY_LOGIN --password-stdin 
    - docker build --tag $DOCKER_REGISTRY_NAME/crm-$CI_COMMIT_BRANCH:$CI_COMMIT_SHORT_SHA -f crm/Dockerfile .
    - docker push $DOCKER_REGISTRY_NAME/crm-$CI_COMMIT_BRANCH:$CI_COMMIT_SHORT_SHA
  after_script:
    - docker logout
  only: 
    - development
    - master

get_kubeconfig_for_gitlab_ci:
  stage: get_kube_config
  image: google/cloud-sdk:latest
  script:
    - echo $SERVICEACCOUNT | base64 -d | gcloud auth activate-service-account --key-file=-
    - gcloud container clusters get-credentials gke-cluster-$CI_COMMIT_BRANCH --region europe-west3 --project curse-work
    - kubectl get nodes
    - cat ~/.kube/config > /dev/null
    - 'curl --request PUT --header "PRIVATE-TOKEN: $GITLAB_TOKEN" "https://gitlab.com/api/v4/projects/18278752/variables/KUBE_CONFIG" --form "value=$(cat ~/.kube/config | base64 -w0)" > /dev/null'
  only:
    - master
    - development

helm:diff:
  extends: .helmfile
  stage: helm-environments-diff
  script: helmfile -f deploy-environment diff
  only:
    refs:
      - master
      - development    
    # changes:
    #   - deploy-environment/*

helm:apply:
  extends: .helmfile
  stage: helm-environments-apply
  script:
    - sed -i "s/__namespace__/$CI_COMMIT_BRANCH/" ./devops/namespace.yaml
    - kubectl apply -f devops/namespace.yaml
    - helmfile -f deploy-environment sync
  only:
    refs:
      - master
      - development
    # changes:
    #   - deploy-environment/*  

push_secrets_restore_db:
  extends: .google-kubectl
  stage: restore_db
  script: 
    - echo $SECRETS | base64 -d > secrets.yaml
    - sed -i "s/__namespace__/$CI_COMMIT_BRANCH/" secrets.yaml
    - kubectl apply -f secrets.yaml
    - sed -i "s/__namespace__/$CI_COMMIT_BRANCH/" devops/postgres.yaml
    - kubectl apply -f devops/postgres.yaml
    - sleep 45
    - >
      if kubectl -n ${CI_COMMIT_BRANCH} exec  $(kubectl -n ${CI_COMMIT_BRANCH} get pods | grep postgres-dev | awk '{print $1}') -- psql -U crm crm -c "select * from account_emailaddress limit 1;"; then
        echo DB restored true
      else
        kubectl -n ${CI_COMMIT_BRANCH} cp devops/db.2020.04 $(kubectl -n ${CI_COMMIT_BRANCH} get pods | grep postgres-dev | awk '{print $1}'):/tmp
        kubectl -n ${CI_COMMIT_BRANCH} exec -i $(kubectl -n ${CI_COMMIT_BRANCH} get pods | grep postgres-dev | awk '{print $1}') -- bash -c "pg_restore --no-privileges --no-owner  -d crm -U crm /tmp/db.2020.04"
      fi;    
  only: 
    - master
    - development

deploy_application:
  extends: .google-kubectl
  stage: deploy_application
  script:
    - mkdir ./.generated
    - cp devops/templates/*.yaml ./.generated/
    - export new_external_url=$(kubectl -n nginx-ingress get service | grep controll | awk '{print $4}' | head -n 1).nip.io
    - echo ${new_external_url}
    - sed -i "s/robocraftlab\.ru/${new_external_url}/" ./.generated/*
    - sed -i "s/__APP__/$CI_COMMIT_BRANCH/" ./.generated/*
    - sed -i "s/__TAG__/$CI_COMMIT_SHORT_SHA/" ./.generated/*
    - sed -i "s/__namespace__/$CI_COMMIT_BRANCH/" ./.generated/*
    - >
      if [[ "${CI_COMMIT_BRANCH}" == "master" ]]; then
          sed -i "s/__REPLICAS__/${REPLICAS_MASTER}/" ./.generated/*
      else
          sed -i "s/__REPLICAS__/${REPLICAS_DEVEL}/" ./.generated/*
      fi      
    - >
      for i in ./.generated/*.yaml; do
        kubectl apply -f "$i"
      done
    - echo "visit site https://$new_external_url"
    - echo "visit admin site https://$new_external_url/_admin_r0b0"
    - echo "visit monitoring site https://grafana.$new_external_url"
    - echo "visit flower monitoring http://flower.$new_external_url"
    - echo "visit promitheus monitoring http://prometheus.$new_external_url"
  only:
    - master
    - development